package mdd.client;

import javafx.geometry.Point2D;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.Tab;
import javafx.scene.input.MouseButton;
import javafx.scene.input.MouseEvent;
import org.json.simple.JSONObject;

public class WorkBench extends Tab implements IGUIEventClient{
    private ScrollPane _scrollPane;
    private Processor _processor;
    private Point2D _pos = new Point2D(0.0f,0.0f);
    private GUIEventHandler _eventHandler;

    public WorkBench(Processor processor){
        super(processor.getAsPrefix().toString());

        _eventHandler = GUIEventHandler.getEventHandler();
        _eventHandler.addEventListener(this);
        _processor = processor;
        setId(_processor.getAsPrefix().toString());
        _scrollPane = new ScrollPane(_processor.all);
        setContent(_scrollPane);
        //setContent(_processor.all);
    }

    @Override
    public void processGUIEvent(String event, JSONObject args) {

    }

    @Override
    public void close() throws Exception {
        _eventHandler.removeEventListener(this);
    }
}
